unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, TAGraph, Forms, Controls, Graphics, Dialogs,
  ExtCtrls, Spin, StdCtrls;

type

  { TForm1 }

  TForm1 = class(TForm)
    PaintBox1: TPaintBox;
    ScrollBar1: TScrollBar;
    procedure PaintBox1Paint(Sender: TObject);
    procedure ScrollBar1Change(Sender: TObject);
  private

  public

  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

uses
  Math;

function RotatePoint(const APoint: TPoint; AAngle: Double): TPoint;
var
  sa, ca: Extended;
begin
  SinCos(AAngle, sa, ca);
  Result.X := Round(ca * APoint.X - sa * APoint.Y);
  Result.Y := Round(sa * APoint.X + ca * APoint.Y);
end;

{ TForm1 }

procedure TForm1.PaintBox1Paint(Sender: TObject);
var
  x0, y0: Integer;
  txt: String;
  w, h: Integer;
  P: array[0..4] of TPoint;
  i: Integer;
  R: TRect;
begin
  txt := 'Hallo';
  Paintbox1.canvas.Font.Size := 18;
  w := Paintbox1.Canvas.TextWidth(txt);
  h := Paintbox1.Canvas.TextHeight(txt);
  x0 := Paintbox1.Width div 2;
  y0 := Paintbox1.Height div 2;

  Paintbox1.canvas.Font.Orientation := round(10 * Scrollbar1.Position);

  // Eckpunkte des ungedrehten, den Text umhüllenden Rechtecks
  P[0] := Point(0, 0);
  P[1] := Point(0, h);
  P[2] := Point(w, h);
  P[3] := Point(w, 0);
  P[4] := P[0];

  // Dieses Rechteck drehen...
  for i:= 1 to 3 do
    P[i] := RotatePoint(P[i], DegToRad(-Scrollbar1.Position));
  // ... zum Text verschieben ...
  for i:= 0 to High(P) do
    P[i] := Point(P[i].X + x0, P[i].Y + y0);
  // ... und als Polygon zeichnen
  Paintbox1.Canvas.Pen.Style := psSolid;
  Paintbox1.canvas.Pen.Color := clBlue;
  Paintbox1.Canvas.Polygon(P, 5);

  // Das den gedrehten Text einhüllende, achsenparallele Rechteck bestimmen...
  R.Left := MinValue([P[0].X, P[1].X, P[2].X, P[3].X, P[4].X]);
  R.Right := MaxValue([P[0].X, P[1].X, P[2].X, P[3].X, P[4].X]);
  R.Top := MinValue([P[0].Y, P[1].Y, P[2].Y, P[3].Y, P[4].Y]);
  R.Bottom := MaxValue([P[0].Y, P[1].Y, P[2].Y, P[3].Y, P[4].Y]);
  // ... und ausgeben
  Paintbox1.Canvas.Pen.Style := psDot;
  Paintbox1.Canvas.Pen.Color := clBlue;
  Paintbox1.Canvas.Brush.Style := bsClear;
  Paintbox1.Canvas.Rectangle(R);

  // Text-Startpunkt als Drehzentrum markieren
  Paintbox1.Canvas.Pen.Style := psSolid;
  paintbox1.Canvas.Pen.color := clRed;
  Paintbox1.canvas.Line(x0 - 8, y0, x0 + 8, y0);
  Paintbox1.Canvas.Line(x0, y0 - 8, x0, y0 + 8);

  // Text ausgeben
  Paintbox1.Canvas.Brush.Style := bsClear;
  Paintbox1.Canvas.TextOut(x0, y0, txt);
end;

procedure TForm1.ScrollBar1Change(Sender: TObject);
begin
  paintbox1.Invalidate;
end;


end.

